/***************************************************************************
 *            utils.h
 *
 *  Tue Jun 29 19:53:49 2004
 *  Copyright  2004  Michael Rasmussen
 *  mir@miras.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _UTILS_H
#define _UTILS_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <syslog.h>
#include <fcntl.h>
	
int		debug;
int		deamon;
pid_t	pid, sid;

void	sanitize(char *str);
char	*standardHeader(int code, char *msg, char *type);
int		http_reply(int fd, FILE **fpp, int code, char *msg, char *type, char *content);
void	not_implemented(int fd);
void	do_404(char *item, int fd);
int		isadir(char *f);
char	*split(char *arg, char c);
int		not_exist(char *f);
void	getowner(char *f);
int		isexec(char *f);
void	skip_rest_of_header(FILE *fp);
int		check_rfc1945(char *cmd);
void	do_head(int fd);
int		is_cgi(char *f);
char	*file_type(char *f);
void 	deamonize(void);
void 	infolog(char *msg);
void 	errorlog(char *msg);

#ifdef __cplusplus
}
#endif

#endif /* _UTILS_H */
