/***************************************************************************
 *            workers.h
 *
 *  Tue Jun 29 19:53:00 2004
 *  Copyright  2004  Michael Rasmussen
 *  mir@miras.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _WORKERS_H
#define _WORKERS_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <pthread.h>
#include <time.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/wait.h>
	
#define stringbuf 1024

struct ownerrec {
	char *Name;
	char *Path;
	int	uid;
	int gid;
};

char			cmdstring[BUFSIZ];
struct ownerrec	optr;
time_t			server_started;
int				server_bytes_sent;
int				server_requests;
int				rfc1945_command;
pthread_mutex_t	parse_command_line;
char 			*mes;

void	do_ls(char *dir, int fd);
void	do_cat(char *f, int fd);
int		built_in(char *arg, int fd);
void	do_exec(char *prog, int fd);
void	process_rq(char *rq, int fd);
void	*handle_call(void *fdptr);


#ifdef __cplusplus
}
#endif

#endif /* _WORKERS_H */
