/***************************************************************************
 *            socklib.c
 *
 *  Tue Jun 15 01:33:49 2004
 *  Copyright  2004  Michael Rasmussen
 *  mir@miras.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "socklib.h"

int make_server_socket_q(int portnum, int backlog) {
	struct	sockaddr_in	saddr;
	struct	hostent	*hp;
	char 	hostname[HOSTLEN];
	int		sock_id;
	
	sock_id = socket(PF_INET, SOCK_STREAM, 0);
	if (sock_id == -1)
		return -1;
	
	bzero((void *) &saddr, sizeof(saddr));
	gethostname(hostname, HOSTLEN);
	hp = gethostbyname(hostname);
	
	bcopy((void *) hp->h_addr, (void *) &saddr.sin_addr, hp->h_length);
	saddr.sin_port = htons(portnum);
	saddr.sin_family = AF_INET;
	if (bind(sock_id, (struct sockaddr *) &saddr, sizeof(saddr)) != 0)
		return -1;
	
	if (listen(sock_id, backlog) != 0)
		return -1;
	
	return sock_id;
}

int make_server_socket(int portnum) {
	return make_server_socket_q(portnum, BACKLOG);
}

int connect_to_server(char *host, int portnum) {
	int		sock;
	struct	sockaddr_in servadd;
	struct	hostent *hp;
	
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock == -1)
		return -1;
	
	bzero(&servadd, sizeof(servadd));
	hp = gethostbyname(host);
	if (hp == NULL)
		return -1;
	
	bcopy(hp->h_addr, (struct sockaddr *) &servadd.sin_addr, hp->h_length);
	servadd.sin_port = htons(portnum);
	servadd.sin_family = AF_INET;
	
	if (connect(sock, (struct sockaddr *) &servadd, sizeof(servadd)) != 0)
		return -1;
	
	return sock;
}
